=== debian/changelog ===
pdal (1.5.0-3build1) artful; urgency=medium

  * Rebuild against new gdal ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jul 2017 13:06:07 +0200

pdal (1.5.0-3) unstable; urgency=medium

  * Fix SOURCE_DATE_EPOCH use.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 26 Jun 2017 21:24:01 +0200

pdal (1.5.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.0.0, no changes.
  * Add autopkgtest to test installability.
  * Update symbols for hurd-i386.
  * Use pkg-info.mk variables instead of dpkg-parsechangelog output.
  * Add lintian override for spelling-error-in-binary false positive.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 25 Jun 2017 23:19:49 +0200

pdal (1.5.0-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jun 2017 16:11:05 +0200

pdal (1.5.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 07 Apr 2017 11:24:23 +0200

pdal (1.5.0~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for amd64.
  * Drop laszip.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 04 Apr 2017 07:24:19 +0200

pdal (1.5.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright years for Hobu, Inc & Bradley J Chambers.
  * Enable PIE hardening buildflags.
  * Drop kfreebsd.patch, applied upstream.
  * Drop 0001-Add-include.-Should-fix-1484.patch, included upstream.
  * Add patch to fix build without LASzip.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 03 Apr 2017 20:41:43 +0200

pdal (1.4.0-2~exp1) experimental; urgency=medium

  * Add upstream patch to fix FTBFS with GCC 7.
    (closes: #853607)

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 24 Feb 2017 11:45:38 +0100
